use std::{collections::HashMap, fs};

pub fn solve() {
    let path = "res/11/input";

    #[allow(unused)]
    let contents = fs::read_to_string(path).expect("Something went wrong reading the file");

    let mut map: HashMap<usize, usize> = HashMap::new();
    contents
        .trim()
        .split(' ')
        .map(|n| n.parse::<usize>().unwrap())
        .for_each(|n| {
            map.insert(n, 1);
        });

    for _ in 0..25 {
        map = blink(map);
    }

    let result: usize = map.iter().map(|(_, v)| v).sum();

    println!("Result 1: {}", result);

    for _ in 0..50 {
        map = blink(map);
    }

    let result: usize = map.iter().map(|(_, v)| v).sum();

    println!("Result 2: {}", result);
}

fn blink(map: HashMap<usize, usize>) -> HashMap<usize, usize> {
    let mut new_map: HashMap<usize, usize> = HashMap::new();
    for (k, v) in map.iter() {
        if *k == 0 {
            *new_map.entry(1).or_insert(0) += *v;
        } else if k.to_string().len() % 2 == 0 {
            // split num into two halves
            let n1 = k
                .to_string()
                .chars()
                .take(k.to_string().len() / 2)
                .collect::<String>()
                .parse::<usize>()
                .unwrap();
            let n2 = k
                .to_string()
                .chars()
                .skip(k.to_string().len() / 2)
                .collect::<String>()
                .parse::<usize>()
                .unwrap();
            *new_map.entry(n1).or_insert(0) += *v;
            *new_map.entry(n2).or_insert(0) += *v;
        } else {
            *new_map.entry((*k) * 2024).or_insert(0) += *v;
        }
    }
    new_map
}
